﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using Syncfusion.SfSchedule.XForms;
using Xamarin.Forms;

namespace ScheduleApp
{
	public partial class ScheduleAppPage : ContentPage
	{
		ScheduleAppointment appointment;
		ScheduleAppointmentCollection appCollection;
		public ScheduleAppPage()
		{
			InitializeComponent();
			appointment = new ScheduleAppointment();
			appCollection = new ScheduleAppointmentCollection();
			appointment.StartTime = DateTime.Now.Date.AddHours(10);
			appointment.EndTime = DateTime.Now.Date.AddHours(12);
			appointment.Color = Color.Violet;
			appointment.Subject = "GoToMeeting";
			appCollection.Add(appointment);
			Schedule.DataSource = appCollection;

			//To set the Default option overlay. if we set default, appointment will not visible.
			Schedule.AppointmentViewLayout = ViewLayoutOptions.Overlay;
			Schedule.OnAppointmentLoadedEvent+= Schedule_OnAppointmentLoadedEvent;

		}

		void Schedule_OnAppointmentLoadedEvent(object sender, AppointmentLoadedEventArgs e)
		{
			StackLayout mainLayout = new StackLayout();

			mainLayout.Orientation = StackOrientation.Horizontal;
			mainLayout.VerticalOptions = LayoutOptions.FillAndExpand;
			mainLayout.HorizontalOptions = LayoutOptions.FillAndExpand;
			Button imageView = new Button();
			imageView.BackgroundColor = Color.Transparent;
			imageView.HeightRequest = 100;
			imageView.WidthRequest = 100;
			imageView.Image = "leftArrow.png";
			mainLayout.Padding = new Thickness(Schedule.Width -100-(Schedule.Width/8), Schedule.TimeIntervalHeight/2, 0, 0);
			mainLayout.Children.Add(imageView);
			e.view = mainLayout;
		}
	}
}
